#include <stdlib.h>
#include "upnpd.h"
#include "gateway.h"
#include "sample_util.h"

/*******************************************************************************
 *  IGDDeviceRequestConnection
 ******************************************************************************/
int IGDDeviceRequestConnection()
{
    char value[DS_MAX_VAL_LEN];
    int ret=0;


//we should turn on our WAN device here.

	 system("rc wan restart");

        sprintf(value, "%s", "Connected");

    ret = IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection, DS_WANIPConn_ConnectionStatus, value);
    return(ret);
}


/*******************************************************************************
 *  IGDDeviceForceTermination
 ******************************************************************************/
int IGDDeviceForceTermination()
{
    char value[DS_MAX_VAL_LEN];
    int ret=0;

// we should shutdown our WAN device here.
	system("rc wan stop");

  sprintf(value, "%s", "Disconnected");
  ret = IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection, DS_WANIPConn_ConnectionStatus, value);
  return(ret);
}


/* adding port mapping entry to kernel */
int addPortForward(char *Proto, char *ExtIP, int ExtPort, 
	char *IntIP,int IntPort)
{
	char command[255];
	extern struct GateEnv gate;
	//int entries;
	//char value[DS_MAX_VAL_LEN];

//	printf("%s\n",gate.ext_ifname);

	if(strcmp(gate.ext_ifname,"none")!=0)
	{
		sprintf(command,"/usr/sbin/iptables -t nat -A UPNP -p %s -d %s --dport %d -j DNAT --to %s:%d", Proto, ExtIP, ExtPort, IntIP, IntPort);
		system(command);
		sprintf(command,"/usr/sbin/iptables -A FW_UPNP -p %s -d %s --dport %d -j ACCEPT", Proto, IntIP, IntPort);
		system(command);	
	}

	return (1);
}

/* deleting port mapping entry to kernel */
int delPortForward(char *Proto, char *ExtIP, int ExtPort, 
		char* IntIP, int IntPort)
{
	char command[255];
	extern struct GateEnv gate;
	int entries;
	char value[DS_MAX_VAL_LEN];


//	printf("%s\n",gate.ext_ifname);

	if(strcmp(gate.ext_ifname,"none")!=0)
	{
		sprintf(command, "iptables -t nat -D UPNP -p %s -d %s --dport %d -j DNAT --to %s:%d", Proto, ExtIP, ExtPort, IntIP, IntPort);
		system(command);
		sprintf(command, "iptables -D FW_UPNP -p %s -d %s --dport %d -j ACCEPT", Proto, IntIP, IntPort);
		system(command);
	}

	entries = atoi(ds_service_table[2].VariableStrVal[18]);
	sprintf(value, "%d", entries-1);
	IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection, DS_WANIPConn_PortMappingNumberOfEntries, value);

	return (1);
}

