// Direct save into NVRAM...
//set ssmu reg 0 1200 3229458 sipgate.co.uk/5060 udp sipgate.co.uk 5060 3229458 AWN3CAQU reg_headstart 60
//set ssmu reg 1 1200 5859256 sipgate.co.uk/5060 udp sipgate.co.uk 5060 5859256 59YYZUTC reg_headstart 60
#include "prov_voip_para.h"

int save_prov_voip_para_2_NVRAM(char *cpData)
{
	int iKeyLength = strlen(NVRAM_PROV_SET);
	int iNvramSetFlag = 0;
	char *cpIndex;

	cpIndex = cpData;
	DEBUG_PRINT("Save prov voip to nvram...\n");

	while(1)
	{
		char caNameStr[REG_NAME_LENGTH] = "", caParaStr[REG_NAME_LENGTH] = "";

		cpIndex = strstr(cpIndex, NVRAM_PROV_SET);
		if(cpIndex == NULL)
		{
			DEBUG_PRINT("Do Times: %d:\n", iNvramSetFlag);
			break;
		}
		//DEBUG_PRINT("cpIndex not NULL...\n");
		cpIndex += (iKeyLength + 1);
		get_name_para_from_data(cpIndex, caNameStr, caParaStr);

		if((caNameStr) && (caParaStr))
		{
			iNvramSetFlag ++;
			DEBUG_PRINT("\t\tcaNameStr: %s, \tcaPara Str: %s\n", caNameStr, caParaStr);
			nvram_set(caNameStr, caParaStr);
			//sleep(1);
		}
		DEBUG_PRINT("How many times do iNvramSetFlag:%d\n", iNvramSetFlag);
		//DEBUG_PRINT("cpIndex: %s\n", cpIndex);
	}
	if(iNvramSetFlag)
	{
		DEBUG_PRINT("Commit into NVRAM...\n");
		nvram_commit();
		sleep(1);
	}
	return MSG_OK;
}

int get_name_para_from_data(char *cpIndex, char *cpNameStr, char *cpParaStr)
{
	int iCount = 0;

	//DEBUG_PRINT("\tcpIndex before sub process:\t%s\n", cpIndex);
	while(1)
	{
		if((*cpIndex == '\0') || (*cpIndex == '\r')
			|| (*cpIndex == '\n') || (*cpIndex == ' '))
			break;
		cpNameStr[iCount] = *cpIndex;

		cpIndex ++;
		iCount ++;
	}
	cpNameStr[iCount] = '\0';
	// For space, must add 1.
	cpIndex ++;
	iCount = 0;
	while(1)
	{
		if((*cpIndex == '\0') || (*cpIndex == '\r')
			|| (*cpIndex == '\n'))
			break;
		cpParaStr[iCount] = *cpIndex;

		cpIndex ++;
		iCount ++;
	}
	cpParaStr[iCount] = '\0';
	if(((cpParaStr[0] == '\'') && (cpParaStr[iCount - 1] == '\''))
		|| ((cpParaStr[0] == '\"') && (cpParaStr[iCount - 1] == '\"')))
	{
		reduce_commas_in_para(cpParaStr);
		DEBUG_PRINT("\tReduce commas in Para: %s\n", cpParaStr);
	}
	return MSG_OK;
}

int reduce_commas_in_para(char *cpParaStr)
{
	DEBUG_PRINT("reduce_commas_in_para Begin\n");
	while(1)
	{
		if(*cpParaStr == '\0')
			break;
		*(cpParaStr - 1) = *cpParaStr;
		cpParaStr ++;
	}
	*(cpParaStr - 2) = '\0';
	DEBUG_PRINT("reduce_commas_in_para End\n");

	return MSG_OK;
}
#if 0
int save_prov_voip_para_2_NVRAM(char *cpData)
{
	struct sVOIPPARA_INFO sVoipPara_Info;

	memset(&sVoipPara_Info, 0, sizeof(struct sVOIPPARA_INFO));
	//DEBUG_PRINT("Save cfg in memset...\n");
	get_prov_voip_from_prov_cfg_file(cpData, &sVoipPara_Info);
	//DEBUG_PRINT("Save cfg in get_prov_voip_from_prov_cfg_file(cpData, &sVoipPara_Info)...\n");

	update_prov_voip_into_NVRAM(&sVoipPara_Info);
	//DEBUG_PRINT("Save cfg in update_prov_voip_into_NVRAM(&sVoipPara_Info)...\n");

	return MSG_OK;
}
#endif
int get_prov_voip_from_prov_cfg_file(char *cpData, struct sVOIPPARA_INFO *spVoipPara)
{
	get_line1_voip_para(cpData, spVoipPara);
	get_line2_voip_para(cpData, spVoipPara);
	get_share_voip_para(cpData, spVoipPara);
	return MSG_OK;
}

int get_share_voip_para(char *cpData, struct sVOIPPARA_INFO *spVoipPara)
{
	get_spec_data_in_data(cpData, CFG_FILE_TOTAL_VAD, spVoipPara->caVoip_Vad_Enable);
	DEBUG_PRINT("get_spec_data_in_data(cpData, CFG_FILE_TOTAL_VAD...\n");
	if(strcmp(spVoipPara->caVoip_Vad_Enable, "on") == 0)
	{
		strcpy(spVoipPara->caVoip_Vad_Enable, "enable");
		spVoipPara->iVoip_SI_Time =
				get_integer_para_from_cfg_file(cpData, PROV_VOIP_SI_DETECT_TIME);

		get_timeout_from_cfg_file(cpData, CFG_FILE_TOTAL_FL_DIGIT_TIMEOUT, spVoipPara);

		get_spec_data_in_data(cpData, CFG_FILE_TOTAL_ATPM_ACTION_KEY, spVoipPara->caVoip_Atpm_Key);

	}
	else
	{
		strcpy(spVoipPara->caVoip_Vad_Enable, "disable");
	}
	spVoipPara->iAllSip_LocalPort =
			get_integer_para_from_cfg_file(cpData, CFG_FILE_TOTAL_SIP_LOCAL_PORT);
	spVoipPara->iAllStarting_RtpPort =
			get_integer_para_from_cfg_file(cpData, CFG_FILE_TOTAL_STARTING_RTP_PORT);
	return MSG_OK;
}

int get_integer_para_from_cfg_file(char *cpData, char *cpKeyWord)
{
	int iRetValue = 0;
	char caTmp[REG_TEL_NUM_LENGTH] = "";

	//DEBUG_PRINT("Before Get Integer Parameter:%s\n", cpKeyWord);
	get_spec_data_in_data(cpData, cpKeyWord, caTmp);
	//DEBUG_PRINT("Get Integer Parameter for Cfg File before atoi:%s\n", caTmp);
	iRetValue = atoi(caTmp);
	DEBUG_PRINT("Get Integer Parameter for Cfg File:\n\t%s: %d\n"
			, cpKeyWord, iRetValue);

	return iRetValue;
}

int get_timeout_from_cfg_file(char *cpData, char *cpKeyWord, struct sVOIPPARA_INFO *spVoipPara)
{
	int iTmp = 0;
	char caTmp[VOIP_SIP_CMD_LENGTH] = "";
	char caWord[12] = "";

	get_spec_data_in_data(cpData, cpKeyWord, caTmp);
	if(caTmp)
	{
		sscanf(caTmp, "%d %d %d %s", &iTmp, &spVoipPara->iVoip_FD_Timeout, &spVoipPara->iVoip_LD_Timeout, caWord);

		printf("Get Timeout:\n\tFirst: %d, Last: %d\n", spVoipPara->iVoip_FD_Timeout, spVoipPara->iVoip_LD_Timeout);
	}

	return MSG_OK;
}

int get_line1_voip_para(char *cpData, struct sVOIPPARA_INFO *spVoipPara)
{
	if(strstr(cpData, CFG_FILE_LINE1_ENABLE_DISABLE) == NULL)
	{
		strcpy(spVoipPara->caLine1Enable, "enable");

		get_spec_data_in_data(cpData, CFG_FILE_LINE1_DISPLAY_NAME, spVoipPara->caLine1DisplayName);
		spVoipPara->iLine1Voip_Pref_Fax_Codec = 
			get_integer_para_from_cfg_file(cpData, CFG_FILE_LINE1_PREFER_FAX_CODEC);

		spVoipPara->iLine1Voip_Pref_Codec = 
			get_integer_para_from_cfg_file(cpData, CFG_FILE_LINE1_PREFER_CODEC);
		spVoipPara->iLine1Voip_Ring_Id = 
			get_integer_para_from_cfg_file(cpData, CFG_FILE_LINE1_PREFER_RING_ID);
		if(spVoipPara->iLine1Voip_Ring_Id < 0)
		{
			strcpy(spVoipPara->caLine1Voip_RingValid, "disable");
		}
		else
		{
			strcpy(spVoipPara->caLine1Voip_RingValid, "enable");
		}

		get_register_para_in_string(cpData, CFG_FILE_LINE1_REGISTER_TOTAL,spVoipPara);
		// Must use the "set tcid 0 cid number", it's acturally really....
		get_spec_data_in_data(cpData, CFG_FILE_LINE1_TEL_NUM, spVoipPara->caLine1TelNum);
	}
	else
		strcpy(spVoipPara->caLine1Enable, "disable");

	return MSG_OK;
}

int get_line2_voip_para(char *cpData, struct sVOIPPARA_INFO *spVoipPara)
{
	if(strstr(cpData, CFG_FILE_LINE2_ENABLE_DISABLE) == NULL)
	{
		strcpy(spVoipPara->caLine2Enable, "enable");
		
		get_spec_data_in_data(cpData, CFG_FILE_LINE2_DISPLAY_NAME, spVoipPara->caLine2DisplayName);
		spVoipPara->iLine2Voip_Pref_Fax_Codec = 
			get_integer_para_from_cfg_file(cpData, CFG_FILE_LINE2_PREFER_FAX_CODEC);
		spVoipPara->iLine2Voip_Pref_Codec = 
			get_integer_para_from_cfg_file(cpData, CFG_FILE_LINE2_PREFER_CODEC);
		spVoipPara->iLine2Voip_Ring_Id = 
			get_integer_para_from_cfg_file(cpData, CFG_FILE_LINE2_PREFER_RING_ID);
		if(spVoipPara->iLine2Voip_Ring_Id < 0)
		{
			strcpy(spVoipPara->caLine2Voip_RingValid, "disable");
		}
		else
		{
			strcpy(spVoipPara->caLine2Voip_RingValid, "enable");
		}

		get_register_para_in_string(cpData, CFG_FILE_LINE2_REGISTER_TOTAL,spVoipPara);
		// Must use the "set tcid 1 cid number", it's acturally really....
		get_spec_data_in_data(cpData, CFG_FILE_LINE2_TEL_NUM, spVoipPara->caLine2TelNum);
	}
	else
	{
		strcpy(spVoipPara->caLine2Enable, "disable");
	}

	return MSG_OK;
}

int get_register_para_in_string(char *cpData, char *cpKeyWord, struct sVOIPPARA_INFO *spVoipPara)
{
	char caTmp[VOIP_SIP_CMD_LENGTH] = "", caTmpData[VOIP_SIP_CMD_LENGTH] = "";
	
	get_spec_data_in_data(cpData, cpKeyWord, caTmp);
	if(caTmp)
	{
		char caLocal[REG_NAME_LENGTH] = "";
		if(strcmp(cpKeyWord, CFG_FILE_LINE1_REGISTER_TOTAL) == 0)
		{
			voip_string_to_para(caTmp, &spVoipPara->iLine1Sip_Reg_Expire
							, spVoipPara->caLine1TelNum
							, caLocal
							, spVoipPara->caLine1Sip_Reg_Server
							, &spVoipPara->iLine1Sip_Reg_Port
							, caTmpData);

			get_string_data(caLocal, spVoipPara->caLine1Sip_Proxy, &spVoipPara->iLine1Sip_Proxy_Port);

			string_distinguish_commas(caTmpData, spVoipPara->caLine1UserName
				, spVoipPara->caLine1Password, &spVoipPara->iLine1Sip_Reg_HeadStart);

			DEBUG_PRINT("File get Line1 cmd:\n\t%d %s %s/%d udp %s %d %s %s reg_headstart %d\n"
				, spVoipPara->iLine1Sip_Reg_Expire, spVoipPara->caLine1TelNum
				, spVoipPara->caLine1Sip_Proxy, spVoipPara->iLine1Sip_Proxy_Port
				, spVoipPara->caLine1Sip_Reg_Server, spVoipPara->iLine1Sip_Reg_Port
				, spVoipPara->caLine1UserName, spVoipPara->caLine1Password
				, spVoipPara->iLine1Sip_Reg_HeadStart);

		}
		else
		{
			voip_string_to_para(caTmp, &spVoipPara->iLine2Sip_Reg_Expire
							, spVoipPara->caLine2TelNum
							, caLocal
							, spVoipPara->caLine2Sip_Reg_Server
							, &spVoipPara->iLine2Sip_Reg_Port
							, caTmpData);

			//sscanf(caTmp, "%d %s %s udp %s %d %s"
			//	, &spVoipPara->iLine2Sip_Reg_Expire, spVoipPara->caLine2TelNum
			//	, caLocal, spVoipPara->caLine2Sip_Reg_Server
			//	, &spVoipPara->iLine2Sip_Reg_Port, caTmpData);

			get_string_data(caLocal, spVoipPara->caLine2Sip_Proxy, &spVoipPara->iLine2Sip_Proxy_Port);

			string_distinguish_commas(caTmpData, spVoipPara->caLine2UserName
				, spVoipPara->caLine2Password, &spVoipPara->iLine2Sip_Reg_HeadStart);

			DEBUG_PRINT("File get Line2 cmd:\n\t%d %s %s/%d udp %s %d %s %s reg_headstart %d\n"	
				, spVoipPara->iLine2Sip_Reg_Expire, spVoipPara->caLine2TelNum
				, spVoipPara->caLine2Sip_Proxy, spVoipPara->iLine2Sip_Proxy_Port
				, spVoipPara->caLine2Sip_Reg_Server, spVoipPara->iLine2Sip_Reg_Port
				, spVoipPara->caLine2UserName, spVoipPara->caLine2Password
				, spVoipPara->iLine2Sip_Reg_HeadStart);
		}
	}
	return MSG_OK;
}

int voip_string_to_para(char *cpTmp
						, int *ipSip_Reg_Expire
						, char *cpTelNum
						, char *cpLocal
						, char *cpSip_Reg_Server
						, int *ipSip_Reg_Port
						, char *cpTmpData)
{
	int iCount1 = 0, iCount2 = 0, iNum = 0, iLen = strlen(cpTmp);
	char caStr[6][REG_NAME_LENGTH];

	//PROV_SYSTEM("%s voip_string_to_para:%s... >> %s", ECHO_CMD, cpTmp, DEBUG_SAVE_DIR);
	for(iNum = 0; iNum < 6; iNum ++)
	{
		//PROV_SYSTEM("%s iNum: %d, iCount1: %d, iCount2: %d... >> %s", ECHO_CMD, iNum, iCount1, iCount2, DEBUG_SAVE_DIR);
		memset(caStr[iNum], '\0', REG_NAME_LENGTH);
		for(iCount2 = 0; iCount2 < iLen - iCount1; iCount2 ++)
		{
			if((cpTmp[iCount1 + iCount2] == ' ') || (cpTmp[iCount1 + iCount2] == '\0'))
				break;
			caStr[iNum][iCount2] = cpTmp[iCount1 + iCount2];
		}
		caStr[iNum][iCount2] = '\0';
		//PROV_SYSTEM("%s caStr[%d]:%s... >> %s", ECHO_CMD, iNum, caStr[iNum], DEBUG_SAVE_DIR);

		iCount1 += iCount2;
		iCount1 ++;
		//DEBUG_PRINT("iNum: %d, iCount1: %d, iCount2: %d\n", iNum, iCount1, iCount2);
		if((iLen < iCount1) || (cpTmp[iCount1] == '\0'))
			break;
	}

	*ipSip_Reg_Expire = atoi(caStr[0]);
//	PROV_SYSTEM("%s ipSip_Reg_Expire: %d... >> %s", ECHO_CMD, *ipSip_Reg_Expire, DEBUG_SAVE_DIR);
	strcpy(cpTelNum, caStr[1]);
//	PROV_SYSTEM("%s cpTelNum: %s... >> %s", ECHO_CMD, cpTelNum, DEBUG_SAVE_DIR);
	strcpy(cpLocal, caStr[2]);
//	PROV_SYSTEM("%s cpLocal: %s... >> %s", ECHO_CMD, cpLocal, DEBUG_SAVE_DIR);
//	PROV_SYSTEM("%s voip_string_to_para:3:%s... >> %s", ECHO_CMD, caStr[3], DEBUG_SAVE_DIR);
	strcpy(cpSip_Reg_Server, caStr[4]);
//	PROV_SYSTEM("%s cpSip_Reg_Server: %s... >> %s", ECHO_CMD, cpSip_Reg_Server, DEBUG_SAVE_DIR);
	*ipSip_Reg_Port = atoi(caStr[5]);
//	PROV_SYSTEM("%s ipSip_Reg_Port:%d... >> %s", ECHO_CMD, *ipSip_Reg_Port, DEBUG_SAVE_DIR);

	for(iCount2 = 0; iCount2 < iLen - iCount1; iCount2 ++)
	{
		if(cpTmp[iCount1 + iCount2] == '\0')
			break;
		cpTmpData[iCount2] = cpTmp[iCount1 + iCount2];
	}
	cpTmpData[iCount2] = '\0';
//	PROV_SYSTEM("%s cpTmpData: %s... >> %s", ECHO_CMD, cpTmpData, DEBUG_SAVE_DIR);

	return MSG_OK;
}

void string_distinguish_commas(char *cpTmpData, char *cpUserName, char *cpPassword, int *ipSip_Reg_HeadStart)
{
	int iCount = 0, iCommasFlag = 0, iNum = 0, iValue = 0, iDataLen = strlen(cpTmpData);
	char caReduceData[VOIP_SIP_CMD_LENGTH] = "", caReduceData2[VOIP_SIP_CMD_LENGTH] = "";

	PROV_SYSTEM("%s Distinguish:%s... >> %s", ECHO_CMD, cpTmpData, DEBUG_SAVE_DIR);
	for(iCount = 0; iCount < iDataLen; iCount ++)
	{
		if(cpTmpData[iCount] == '\'')
		{
			iCommasFlag ++;
		}
		if((cpTmpData[iCount] == ' ') && (iCommasFlag != 1))
		{
			//PROV_SYSTEM("%s break:%c... >> %s", ECHO_CMD, cpTmpData, DEBUG_SAVE_DIR);
			break;
		}
		cpUserName[iCount] = cpTmpData[iCount];
	}
	cpUserName[iCount] = '\0';

	//PROV_SYSTEM("%s User Name:%s... >> %s", ECHO_CMD, cpUserName, DEBUG_SAVE_DIR);
	for(iNum = 0; iNum < iDataLen - iCount; iNum ++)
	{
		// Beside the space...
		caReduceData[iNum] = cpTmpData[iNum + iCount + 1];
	}
	caReduceData[iNum] = '\0';
	//PROV_SYSTEM("%s String %d Name:%s... >> %s", ECHO_CMD, iCount, caReduceData, DEBUG_SAVE_DIR);
	iCommasFlag = 0;
	for(iNum = 0; iNum < iDataLen - iCount; iNum ++)
	{
		if(caReduceData[iNum] == '\'')
		{
			//PROV_SYSTEM("%s 2:iCommasFlag:%d... >> %s", ECHO_CMD, iCommasFlag, DEBUG_SAVE_DIR);
			iCommasFlag ++;
		}
		if((caReduceData[iNum] == ' ') && (iCommasFlag != 1))
			break;

		cpPassword[iNum] = caReduceData[iNum];
	}
	cpPassword[iNum] = '\0';
	//DEBUG_PRINT("Cmd:caReduceData:%s\n", caReduceData);
	//PROV_SYSTEM("%s Password:%s... >> %s", ECHO_CMD, cpPassword, DEBUG_SAVE_DIR);

	for(iValue = 0; iValue < iDataLen - iCount - iNum; iValue ++)
	{
		// Beside the space...
		caReduceData2[iValue] = caReduceData[iNum + iCount + iValue + 1];
	}
	caReduceData2[iValue] = '\0';
	//PROV_SYSTEM("%s Password Name:%s... >> %s", ECHO_CMD, caReduceData2, DEBUG_SAVE_DIR);
	//DEBUG_PRINT("Cmd:caReduceData2:%s\n", caReduceData2);
	sscanf(caReduceData2, "reg_headstart %d", ipSip_Reg_HeadStart);

	//PROV_SYSTEM("%s Reg_HeadStart time:%d... >> %s", ECHO_CMD, *ipSip_Reg_HeadStart, DEBUG_SAVE_DIR);

}

int get_string_data(char *cpTmp, char *cpLine1Sip_Proxy, int *ipValue)
{
	int iCount = 0;
	char *cpIndex;

	cpIndex = strchr(cpTmp, '/');
	if(cpIndex == NULL)
	{
		*ipValue = 0;
		memcpy(cpLine1Sip_Proxy, '\0', strlen(cpLine1Sip_Proxy));
		return ERROR;
	}
//#if 1
	DEBUG_PRINT("cpIndex: %s\n", cpIndex);
//#endif
	iCount = strlen(cpTmp) - strlen(cpIndex);
	DEBUG_PRINT("sting:%s\n/ in length:%d\n", cpTmp, iCount);
	cpIndex ++;
	*ipValue = atoi(cpIndex);
	memcpy(cpLine1Sip_Proxy, cpTmp, iCount);
	//cpLine1Sip_Proxy[iCount] = '\0';

	return MSG_OK;
}

int get_spec_data_in_data(char *cpData, char *cpKeyWord, char *cpRet)
{
	int iCount = 0;
	char *cpIndex;

	cpIndex = strstr(cpData, cpKeyWord);
	if(cpIndex == NULL)
	{
		cpRet[0] = '\0';
		return ERROR;
	}
	cpIndex += strlen(cpKeyWord) + 1;	//Added 1 space
	while(1)
	{
		if((*cpIndex == '\n') || (*cpIndex == '\0') || (*cpIndex == '\r'))
			break;
		cpRet[iCount] = *cpIndex;

		iCount ++;
		cpIndex ++;
	}
	cpRet[iCount] = '\0';
	DEBUG_PRINT("Get spec cmd in data:\n\t%s\n", cpRet);

	return MSG_OK;
}

int update_prov_voip_into_NVRAM(struct sVOIPPARA_INFO *spVoipPara)
{
	int iFlag = 0;

	PROV_SYSTEM("%s update prov. voip para into NVRAM > %s", ECHO_CMD, TMP_VOIP_PARA_SAVE_FILE);
	if(strcmp(spVoipPara->caLine1Enable, "enable") == 0)
	{
		iFlag = 1;
		PROV_SYSTEM("%s spVoipPara-\\>caLine1Enable=enable >> %s", ECHO_CMD, TMP_VOIP_PARA_SAVE_FILE);
		update_NVRAM_prov_line1_voip(spVoipPara);
	}
	else
	{
		PROV_SYSTEM("%s spVoipPara-\\>caLine1Enable=disable >> %s", ECHO_CMD, TMP_VOIP_PARA_SAVE_FILE);

	}
	if(strcmp(spVoipPara->caLine2Enable, "enable") == 0)
	{
		PROV_SYSTEM("%s spVoipPara-\\>caLine2Enable=enable >> %s", ECHO_CMD, TMP_VOIP_PARA_SAVE_FILE);
		iFlag = 2;
		update_NVRAM_prov_line2_voip(spVoipPara);
	}
	if(strcmp(spVoipPara->caVoip_Vad_Enable, "enable") == 0)
	{
		PROV_SYSTEM("%s spVoipPara-\\>caVoip_Vad_Enable=enable >> %s", ECHO_CMD, TMP_VOIP_PARA_SAVE_FILE);
		iFlag = 3;
		update_NVRAM_prov_vad_voip(spVoipPara);
	}
	if(strcmp(spVoipPara->caVoip_Pstn_Enable, "enable") == 0)
	{
		PROV_SYSTEM("%s spVoipPara-\\>caVoip_Pstn_Enable=enable >> %s", ECHO_CMD, TMP_VOIP_PARA_SAVE_FILE);
		iFlag = 4;
		nvram_set(PROV_VOIP_PSTN_ENABLE, spVoipPara->caVoip_Pstn_Enable);
		sleep(1);
	}
	if(iFlag)
		nvram_commit();

	return MSG_OK;	
}

int update_NVRAM_prov_line1_voip(struct sVOIPPARA_INFO *spVoipPara)
{
	char caTmp[EN_DISABLE_LENGTH] = "", caNameTmp[REG_NAME_LENGTH] = "";

	PROV_SYSTEM("%s update_NVRAM_prov_line1_voip: %s >> %s", ECHO_CMD, spVoipPara->caLine1Enable, TMP_VOIP_PARA_SAVE_FILE);
	nvram_set(PROV_VOIP_LINE1_ENABLE, spVoipPara->caLine1Enable);
	sleep(1);

	reduce_2_special_chars(caNameTmp, spVoipPara->caLine1UserName);
	PROV_SYSTEM("%s PROV_VOIP_LINE1_USERNAME: %s >> %s", ECHO_CMD, caNameTmp, TMP_VOIP_PARA_SAVE_FILE);
	nvram_set(PROV_VOIP_LINE1_USERNAME, caNameTmp);
	sleep(1);

	reduce_2_special_chars(caNameTmp, spVoipPara->caLine1Password);
	PROV_SYSTEM("%s PROV_VOIP_LINE1_PASSWORD: %s >> %s", ECHO_CMD, caNameTmp, TMP_VOIP_PARA_SAVE_FILE);
	nvram_set(PROV_VOIP_LINE1_PASSWORD, caNameTmp);
	sleep(1);

	PROV_SYSTEM("%s PROV_VOIP_LINE1_TEL_NUM: %s >> %s", ECHO_CMD, spVoipPara->caLine1TelNum, TMP_VOIP_PARA_SAVE_FILE);
	nvram_set(PROV_VOIP_LINE1_TEL_NUM, spVoipPara->caLine1TelNum);
	sleep(1);

	reduce_2_special_chars(caNameTmp, spVoipPara->caLine1DisplayName);
	nvram_set(PROV_VOIP_LINE1_TEL_NAME, caNameTmp);
	sleep(1);
	nvram_set(PROV_SIP_LINE1_REG_SERVER, spVoipPara->caLine1Sip_Reg_Server);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine1Sip_Reg_Expire);
	nvram_set(PROV_SIP_LINE1_REG_EXPIRE, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine1Sip_Reg_HeadStart);
	nvram_set(PROV_SIP_LINE1_REG_HEADSTART, caTmp);
	sleep(1);
	nvram_set(PROV_VOIP_LINE1_RING_VALID, spVoipPara->caLine1Voip_RingValid);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine1Voip_Ring_Id);
	nvram_set(PROV_VOIP_LINE1_RIND_ID, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine1Voip_Pref_Fax_Codec);
	nvram_set(PROV_VOIP_LINE1_PREF_FAX_CODEC, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine1Voip_Pref_Codec);
	nvram_set(PROV_VOIP_LINE1_PREF_CODEC, caTmp);
	sleep(1);
	nvram_set(PROV_SIP_LINE1_PROXY, spVoipPara->caLine1Sip_Proxy);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine1Sip_Proxy_Port);
	nvram_set(PROV_SIP_LINE1_PROXY_PORT, caTmp);
	sleep(1);
	if(strcmp(spVoipPara->caLine1Sip_Proxy, spVoipPara->caLine1Sip_Reg_Server))
	{
		nvram_set(PROV_SIP_LINE1_OUTPROXY_ENABLE, "enable");
	}
	else
	{
		nvram_set(PROV_SIP_LINE1_OUTPROXY_ENABLE, "disable");
	}
	sleep(1);
	return MSG_OK;
}

void reduce_2_special_chars(char *cpTmp, char *cpData)
{
	memset(cpTmp, '\0', REG_NAME_LENGTH);
	if(cpData == NULL)
		return;
	if((cpData[0] == '\'') && (cpData[strlen(cpData) - 1] == '\''))
	{
		int iCount = 0;
		for(iCount = 0; iCount < strlen(cpData) - 2; iCount ++)
			cpTmp[iCount] = cpData[iCount + 1];
		//PROV_SYSTEM("%s before-Cmd:%s... >> %s", ECHO_CMD, cpData, DEBUG_SAVE_DIR);
		//PROV_SYSTEM("%s after-Cmd:%s... >> %s", ECHO_CMD, cpTmp, DEBUG_SAVE_DIR);
	}
	else
		strcpy(cpTmp, cpData);
}

int transfer_digit_to_str(char *cpTmp, int iValue)
{
	memset(cpTmp, 0, EN_DISABLE_LENGTH);
	sprintf(cpTmp, "%d", iValue);

	return MSG_OK;
}

int update_NVRAM_prov_line2_voip(struct sVOIPPARA_INFO *spVoipPara)
{
	char caTmp[EN_DISABLE_LENGTH] = "", caNameTmp[REG_NAME_LENGTH] = "";

	nvram_set(PROV_VOIP_LINE2_ENABLE, spVoipPara->caLine2Enable);
	sleep(1);

	reduce_2_special_chars(caNameTmp, spVoipPara->caLine2UserName);
	nvram_set(PROV_VOIP_LINE2_USERNAME, caNameTmp);
	sleep(1);
	reduce_2_special_chars(caNameTmp, spVoipPara->caLine2Password);
	nvram_set(PROV_VOIP_LINE2_PASSWORD, caNameTmp);
	sleep(1);
	nvram_set(PROV_VOIP_LINE2_TEL_NUM, spVoipPara->caLine2TelNum);
	sleep(1);
	reduce_2_special_chars(caNameTmp, spVoipPara->caLine2DisplayName);
	nvram_set(PROV_VOIP_LINE2_TEL_NAME, caNameTmp);
	sleep(1);
	nvram_set(PROV_SIP_LINE2_REG_SERVER, spVoipPara->caLine2Sip_Reg_Server);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine2Sip_Reg_Expire);
	nvram_set(PROV_SIP_LINE2_REG_EXPIRE, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine2Sip_Reg_HeadStart);
	nvram_set(PROV_SIP_LINE2_REG_HEADSTART, caTmp);
	sleep(1);
	nvram_set(PROV_VOIP_LINE2_RING_VALID, spVoipPara->caLine2Voip_RingValid);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine2Voip_Ring_Id);
	nvram_set(PROV_VOIP_LINE2_RING_ID, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine2Voip_Pref_Fax_Codec);
	nvram_set(PROV_VOIP_LINE2_PREF_FAX_CODEC, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine2Voip_Pref_Codec);
	nvram_set(PROV_VOIP_LINE2_PREF_CODEC, caTmp);
	sleep(1);
	nvram_set(PROV_SIP_LINE2_PROXY, spVoipPara->caLine2Sip_Proxy);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iLine2Sip_Proxy_Port);
	nvram_set(PROV_SIP_LINE2_PROXY_PORT, caTmp);
	sleep(1);
	if(strcmp(spVoipPara->caLine2Sip_Proxy, spVoipPara->caLine2Sip_Reg_Server))
	{
		nvram_set(PROV_SIP_LINE2_OUTPROXY_ENABLE, "enable");
	}
	else
	{
		nvram_set(PROV_SIP_LINE2_OUTPROXY_ENABLE, "disable");
	}
	sleep(1);
	return MSG_OK;
}

int update_NVRAM_prov_vad_voip(struct sVOIPPARA_INFO *spVoipPara)
{
// VAD parameters...	
	char caTmp[EN_DISABLE_LENGTH] = "";

	nvram_set(PROV_VOIP_VAD_ENABLE, spVoipPara->caVoip_Vad_Enable);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iVoip_SI_Time);
	nvram_set(PROV_VOIP_SI_DETECT_TIME, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iVoip_FD_Timeout);
	nvram_set(PROV_VOIP_FD_TIMEOUT, caTmp);
	sleep(1);
	transfer_digit_to_str(caTmp, spVoipPara->iVoip_LD_Timeout);
	nvram_set(PROV_VOIP_LD_TIMEOUT, caTmp);
	sleep(1);
	nvram_set(PROV_VOIP_ATPM_KEY, spVoipPara->caVoip_Atpm_Key);
	sleep(1);

	return MSG_OK;
}
