/* if return non_0, it's to say, the string isn't space... */
/* if return 0, ..., the string is all space... */
/*	isspace()
		checks  for  white-space  characters.   In  the  "C" and "POSIX"
		locales, these are: space,  form-feed  (’\f’),  newline  (’\n’),
		carriage  return (’\r’), horizontal tab (’\t’), and vertical tab (’\v’).
	RETURN VALUE
		The  values  returned  are  nonzero  if  the character c falls into the
		tested class, and a zero value if not.		 */
#include <ctype.h>
#include "provision_tools.h"

int is_string_all_space(char *cpData)
{
	int iCount = 0, iLimit = 0;
	
	if(cpData[0] == '\0')
		return MSG_OK;
	iLimit = strlen(cpData);
	for(iCount = 0; iCount < iLimit; iCount ++)
		if(!isspace((unsigned char)cpData[iCount]))
			return STRING_NON_ALL_SPACE;
	return MSG_OK;
}

void remove_tmp_enc_file(char *cpFileName)
{
	FILE *fpTmp;
	char caTmp[FILENAME_MAX_LEN] = "";

	sprintf(caTmp, "%s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpFileName));
	fpTmp = fopen(caTmp, "r");
	if(fpTmp != NULL)
	{
		fclose(fpTmp);

		sprintf(caTmp, "rm %s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpFileName));
		system(caTmp);
	}
}

void remove_tmp_store_file(char *cpFileName)
{
	FILE *fpTmp;
	char caTmp[FILENAME_MAX_LEN] = "";

	sprintf(caTmp, "%s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(cpFileName));
	fpTmp = fopen(caTmp, "r");
	if(fpTmp == NULL)
		return;
	fclose(fpTmp);

	sprintf(caTmp, "rm %s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(cpFileName));
	system(caTmp);
}
