/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004    Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/
/**************************************************************************/
/*                                                                        */
/*  MODULE:     whalAcxFWTrace.h                                          */
/*  PURPOSE:    Firmware trace information sending agent implementation.  */
/*              It is not going to be available in official release.      */
/*                                                                        */
/**************************************************************************/

#ifndef TIWLAN_HAL_ACXFWTRACE_H
#define TIWLAN_HAL_ACXFWTRACE_H

extern void whal_AcxFWTraceCallback (int bufNum);
extern int  whal_AcxFWTraceInit     (void);
extern int  whal_acxFWTraceShutdown (void);

/* Should be defined elsewhere */
extern int  whal_AcxFWTraceSend(UINT8 *, int);

#define TIWLAN_FW_TRACE_ENTRIES_NUM         512
#define TIWLAN_FW_TRACE_FW_BUF_SIZE         (( TIWLAN_FW_TRACE_ENTRIES_NUM) * 4 )
#define TIWLAN_FW_TRACE_DRIVER_BUF_SIZE     15

#endif // TIWLAN_HAL_ACXFWTRACE_H
