/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*	 MODULE:	dda_wdsDrv.h	  										   */
/*   PURPOSE:	DDA implementation of the WDS driver.				       */
/*																		   */
/***************************************************************************/

#ifndef __DDA_WDS_DRV_H__
#define __DDA_WDS_DRV_H__

#ifdef __DDA_WDS_DRV_C__
#define PUBLIC
#else /* ifdef __DDA_WDS_DRV_C__ */
#define PUBLIC extern
#endif /* ifdef __DDA_WDS_DRV_C__ */

PUBLIC void tiwlan_ddaSendWdsPkt(UINT8 *pBuff, UINT32 length);
PUBLIC int tiwlan_setupWdsNetDevs(int wdsDlDevsNumber);
PUBLIC void tiwlan_ddaRemoveWdsNetDevs(void);
PUBLIC void tiwlan_ddaWdsResumeTransmit(void);
PUBLIC void tiwlan_ddaWdsSuspedTransmit(void);
PUBLIC void tiwlan_ddaWdsResumeTransmit(void);
PUBLIC void tiwlan_ddaWdsSuspedTransmit(void);


#undef PUBLIC
#endif /* ifndef __DDA_WDS_DRV_H__ */
