/**********************************************************************************************************************

  FILENAME:       public_dcs.h

  DESCRIPTION:    Header for DCS (Dynamic Channel Selection).


   Copyright (c) 2004 Texas Instruments Inc. 
   All Rights Reserved This program is the confidential and proprietary 
   product of Texas Instruments Inc.  Any Unauthorized use, reproduction or 
   transfer of this program is strictly prohibited.


***********************************************************************************************************************/


#ifndef PUBLIC_DCS_H
#define PUBLIC_DCS_H

/* #include "public_channels" */

#define NUM_OF_DCS_SAMPLES 120

typedef struct
{ 
  UINT16 samplesNum;
  UINT16 resrved; 	
  UINT16 timeStampDiff[NUM_OF_DCS_SAMPLES]; 

} DcsResponse_t;

typedef struct 
{
    UINT8 /* Channel_e */  channel;  /* What channel should be used for the test */
    UINT8 /* RadioBand_e */ band;   /* What band should be used for the test */
} DcsStart_t;


#endif /* PUBLIC_DCS_H */


