#include "provision_update.h"
#include "voip_fw_update.c"

#define SUBF1
#define SUBF2
#define SUBF3

void stop_some_app_get_buffer(void)
{
	system("/usr/sbin/rc wlan stop &");
	//system("/usr/sbin/rc upnp stop &");
	system("/usr/bin/killall -9 upnpd");
	//creat(MXP_STOP,0x666);
	//while(!mxp_stop_ready())
	//{
	//	sleep(SYSTEM_CMD_INTERVAL_TIME);
	//	DEBUG_PRINT("Waiting fot \"/tmp/mxp_stop\" produce...\n");
	//}
	//system("/usr/bin/killall ggsip");
	system("/usr/sbin/rc voip stop");

	/* if Modem states in Upgrade, the Web would show the upgrading page... */
	creat(UPGRADING,0x666);
}

void start_app_fw_update_failed(void)
{
	system("/usr/sbin/rc wlan start");
	system("/usr/sbin/rc upnp start");
	//creat(MXP_STOP,0x666);
	//system("rm /tmp/mxp_stop");
	
	system("/usr/sbin/rc voip start");

	//creat(UPGRADING,0x666);
}

int process_fw_file_update(struct sPROV_INFORMATION *spProv_Info)
{
	char caTmpFile[FILENAME_MAX_LEN + 10] = "";

	/* Stop some app. to get the enough buffer to upgrade fw (almost 4M) */
	stop_some_app_get_buffer();

	/* Call cgi_update_flash.c...*/
	if(get_fw_file_update_used_tftp(spProv_Info->caFWFileName, spProv_Info->caServerIP, spProv_Info->caFile_Sys_Name, spProv_Info->iTftpDefaultPortNum) != MSG_OK)
	{
		DEBUG_PRINT("Unsuccess get file, maybe you must retry...\n");
		prov_led_blink("u0");
		start_app_fw_update_failed();
		return UNSUCCESS_OPEN_or_GET_FILE;
	}

	sprintf(caTmpFile, "%s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(spProv_Info->caFWFileName));
	if(check_fw_file(caTmpFile) != MSG_OK)
	{
		DEBUG_PRINT("The PID or ... isn't correct, maybe you must get correct...\n");
		//sprintf(caTmpFile, "rm %s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(spProv_Info->caFWFileName));
		unlink(caTmpFile);
		//system(caTmpFile);
		prov_led_blink("u0");
		start_app_fw_update_failed();
		return UNSUCCESS_OPEN_or_GET_FILE;
	}
	system("echo /tmp/echo_prov_fw_update");
	kill_process_to_get_ram();
	system("rm /tmp/echo_prov_fw_update");
	prov_led_blink("u0");
	DEBUG_PRINT("kill process to get ram...\n");
	DEBUG_SYSTEM("echo kill process to get ram... >> /tmp/debugaa");
	prov_led_blink("w1000000");
	if(voip_fw_update(caTmpFile) == MSG_OK)
	{
//		prov_led_blink("r");
		DEBUG_SYSTEM("echo FW File update OK... >> /tmp/debugaa");
		DEBUG_PRINT("FW File update OK...\n");
//		system("reboot");
		prov_led_blink("u0");
		prov_led_blink("r");
		return MSG_OK;
	}
	DEBUG_SYSTEM("echo FW file update failed.. >> /tmp/debugaa");
	DEBUG_PRINT("FW file update failed..\n");
	prov_led_blink("u0");
	prov_led_blink("r");
//	system("reboot");
	return ERROR_MSG_UPDATE_TFTP;
}

void kill_process_to_get_ram(void)
{
	system("/usr/bin/killall atm_monitor >/dev/null 2>&1");
	system("/usr/sbin/rc wan stop >/dev/null 2>&1");
	system("/sbin/rmmod tiatm >/dev/null 2>&1");
	system("/usr/sbin/rc wlan stop");
	system("/sbin/ifconfig eth0 down");
	system("/sbin/ifconfig usb0 down");
}

int get_fw_file_update_used_tftp(char *cpFWFileName, char *cpServerIP, char *cpFileSysName, int iTftpPortNum)
{
	char caCmd[FILENAME_MAX_LEN + 10] = "";

	DEBUG_PRINT("Update FW Server IP: %s\n", cpServerIP);
	/* FW downloading */
	prov_led_blink("u1000000");
	DEBUG_PRINT("\tGetFile %s\n", cpFWFileName);
	DEBUG_PRINT("\t\tTotal Try %d times\n", RETRY_ITEM_TIME);

	/* This will retry 3-times...*/
	if(get_file_provision_tftp(cpFWFileName, cpServerIP, iTftpPortNum) == MSG_OK)
	{
		DEBUG_PRINT("\t\t\tTftp Update OK.....\n");
		return MSG_OK;	//SUCCESS_OPEN_or_GET_FILE;
	}
	else
	{
		ERROR_PRINT("\t\tUpdate by TFTP wasn't success.....\nPlease retry..\n");
		sprintf(caCmd, "rm %s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpFileSysName));
#ifdef PDEBUG_RD
		if(system(caCmd))
		{
			DEBUG_PRINT("\t\t\trm file Fail...\n");
		}
		else
			DEBUG_PRINT("\t\t\trm file OK...\n");
#else
		system(caCmd);
#endif
		DEBUG_PRINT("retry over...\n\tUNSUCCESS_OPEN_or_GET_FILE....\n");
		prov_led_blink("u0");
		return UNSUCCESS_OPEN_or_GET_FILE;
	}
}

int check_cfg_file_pid(struct sPROV_INFORMATION *spProv_Info)
{
#ifdef PDEBUG_RD
	DEBUG_PRINT("checkconfigfilePID: Decrypt Data:\n%s\n", spProv_Info->cpBuffer);
#endif
	if(check_text_pid(spProv_Info) == MSG_OK)	/* MSG_OK = 0 */
	{
		return MSG_OK;
	}
	else
	{
		return ERROR_MSG_CFG_PID_CHECK;
	}
}

int check_cfg_file_mac(struct sPROV_INFORMATION *spProv_Info)
{
#ifdef PDEBUG_RD
	DEBUG_PRINT("check config file Mac: Decrypt Data:\n%s\n", spProv_Info->cpBuffer);
#endif
	if(check_text_mac(spProv_Info) == MSG_OK)	/* MSG_OK = 0 */
	{
		return MSG_OK;
	}
	else
	{
		return ERROR_MSG_CFG_PID_CHECK;
	}
}

int check_fw_file_pid(struct sPROV_INFORMATION *spProv_Info)
{
	if(check_binary_pid(spProv_Info) == MSG_OK)	/* MSG_OK = 0 */
	{
		return MSG_OK;
	}
	else
	{
		return ERROR_MSG_CFG_PID_CHECK;
	}
}

int get_the_position_in_string(char *cpFileData, char *cpKeyString)
{
	char *cpTmp;

	cpTmp = strstr(cpFileData, cpKeyString);
	if(cpTmp == NULL)
	{
		/* Couldn't find the string in File Data... */
		return -100;
	}
	DEBUG_PRINT("Check strstr do it...\n");
#ifdef PDEBUG_RD
	DEBUG_PRINT("Get Data:\n%s\n", cpTmp);
#endif

	return strlen(cpFileData) - strlen(cpTmp);
}

int check_binary_pid(struct sPROV_INFORMATION *spProv_Info)
{
	return MSG_OK;
}

int check_text_pid(struct sPROV_INFORMATION *spProv_Info)
{
	char caGetPidData[DEFAULT_PID_LENGTH] = "";

	DEBUG_PRINT("\n\n\nCheck text pid...\n\n\n");
//	if(get_file_pid_data(caGetPidData, spProv_Info->cpBuffer) != MSG_OK)	//= ERROR_MSG_CFG_PID_CHECK)
	if(get_spec_data_from_file(spProv_Info->cpBuffer, CHECK_PID_STRING, caGetPidData) != MSG_OK)
	{
		DEBUG_PRINT("\n\n\nCheck text pid:~get_file_pid_data...\n\n\n");
		return ERROR_MSG_CFG_PID_CHECK;
	}

	if(!caGetPidData)
	{
		DEBUG_PRINT("\n\n\nCheck text pid:~caGetPidData...\n\n\n");
		return ERROR_MSG_CFG_PID_CHECK;
	}
	//if(strncmp(caGetPidData, TXT_SIC, strlen(TXT_SIC)) == MSG_OK)	/* MSG_OK = 0 */
	if(strcmp(caGetPidData, caDefaultPID) == MSG_OK)	/* MSG_OK = 0 */
	{
		DEBUG_PRINT("Check Text Pid OK....\n");
		return MSG_OK;
	}
	DEBUG_PRINT("Check Text Pid fail....\n");
	return ERROR_MSG_CFG_PID_CHECK;
}

int get_file_pid_data(char *cpGetPidData, char *cpBufferData)
{
	int iCount=10000, iTmp = 0, iPidLeng = strlen(CHECK_PID_STRING);

	DEBUG_PRINT("Check get file pid data: %d\n", iPidLeng);
	iCount = get_the_position_in_string(cpBufferData, CHECK_PID_STRING);
#ifdef PDEBUG_RD
	DEBUG_PRINT("\n\n\n\n\n\n\n\nBuffer Data2: %s\n", cpBufferData);
#endif
	iCount += iPidLeng;
	DEBUG_PRINT("%d, File length(%d) with PID(%d)...\n", iCount, strlen(cpBufferData), iPidLeng);
	if((iCount > strlen(cpBufferData)) || (iCount < iPidLeng))
	{
		/* Couldn't find the Pid in Get File Data... */
		ERROR_PRINT("Couldn't find the Pid in Get File Data...\n");
		return ERROR_MSG_CFG_PID_CHECK;
	}
	while((cpBufferData[iCount] != '\n') && (cpBufferData[iCount] != '\r') && (cpBufferData[iCount] != '\0'))
	{
		cpGetPidData[iTmp] = cpBufferData[iCount];
		iTmp ++;
		iCount ++;
	}
	cpGetPidData[iTmp] = '\0';
	DEBUG_PRINT("Get Pid Data from get file: %s\n", cpGetPidData);
	return MSG_OK;	/* MSG_OK = 0 */
}

int check_file_size_diff(char *cpFileName, char *cpGetData)
{
	FILE *fpOldFile;
	int iCount1, iCount2;
	char caOldName[FILENAME_MAX_LEN] = "";
	char *cpOldData;

	sprintf(caOldName, "%s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(cpFileName));
	DEBUG_PRINT("The old file name: %s\n", caOldName);

	fpOldFile = fopen(caOldName, "r");
	if(fpOldFile == NULL)
	{
		DEBUG_PRINT("Couldn't get the old file name: %s\n", caOldName);
		DEBUG_PRINT("fpOldFile = NULL\n");
		return MSG_OK;	//0;
	}

	if(strlen(cpGetData) == 0)
	{
		DEBUG_PRINT("fpGetFile = NULL\n");
		fclose(fpOldFile);
		return MSG_OK;	//0;
	}
	iCount1 = my_file_length_with_fp(fpOldFile);
	iCount2 = strlen(cpGetData);

	if(iCount1 != iCount2)
	{
		fclose(fpOldFile);
		DEBUG_PRINT("iCount1:%d != iCount2:%d\n", iCount1, iCount2);
		return MSG_OK;	//0;
	}

	cpOldData = (char *)malloc(iCount1*sizeof(char));
	if(!cpOldData)
	{
		fclose(fpOldFile);
		return GET_THE_SAME_FILE_NO_UPDATE;
	}
	fread(cpOldData, iCount1, 1, fpOldFile);

	if(strcmp(cpOldData, cpGetData))
	{
		if(cpOldData)
			free(cpOldData);
		fclose(fpOldFile);
		DEBUG_PRINT("The file data are not the same....\n");
		return  MSG_OK;	//0;
	}

	if(cpOldData)
		free(cpOldData);
	fclose(fpOldFile);
	DEBUG_PRINT("The File the same...\n");
	return GET_THE_SAME_FILE_NO_UPDATE;
}

//a_1
int compare_two_version_same(void)
{
	int iaMtd5Ver[5], iaEtcVer[5], iCount = 0;
	char caMtd5Ver[32]= "", caEtcVer[32] = "";

	for(iCount = 0; iCount < 5; iCount ++)
	{
		iaMtd5Ver[iCount] = 0;
		iaEtcVer[iCount] = 0;
	}

	if(get_etc_version_integer(caEtcVer, iaEtcVer) != MSG_OK)
	{
		/* Couldn't check /etc/version, don't need to update FW in this time... */
		return TWO_SAME_FW_VERSIONS;
	}
	if(get_mtdblock5_version_integer(caMtd5Ver, iaMtd5Ver) != MSG_OK)
	{
		/* It couldn't find the FW version in mtdblock5 file,
			 it's to say, don't need to update FW in this time.... */
		return TWO_SAME_FW_VERSIONS;
	}
	if(check_two_integers_same(iaEtcVer, iaMtd5Ver) != MSG_OK)
	{
		return NEED_TO_UPDATE_FW_FILE;
	}
	else
	{
		return TWO_SAME_FW_VERSIONS;
	}
}

//a_1_2
int get_mtdblock5_version_integer(char *cpOrgVer, int *ipMtd5Ver)
{
	char caData[MAX_CFG_FILE_SIZE] = "";

	if(get_copy_mtdblock5_2_tmp(caData) != MSG_OK)
	{
		return ERROR_MSG_UPDATE_TFTP;
	}

	get_spec_data_from_file(caData, CHECK_FW_UPDATE_FILE_NAME, cpOrgVer);

	if(strstr(caData, "##") == NULL)
	{
		DEBUG_PRINT("\t\tCouldn't find the version string of \"##\" in File Data...\n");
		return ERROR_FW_NO_VERSION;
	}

	sscanf(cpOrgVer, "%*s[^_]%*c%d.%d.%d", &ipMtd5Ver[0], &ipMtd5Ver[1], &ipMtd5Ver[2]);

	DEBUG_PRINT("\t\t\tGet Version from MtdBlock5:\n\t\t\t\t%d.%d.%d\n", ipMtd5Ver[0], ipMtd5Ver[1], ipMtd5Ver[2]);
	return MSG_OK;
}

//a_1_2_1
int get_copy_mtdblock5_2_tmp(char *cpData)
{
	FILE *fpMtd;
	char caCmd[100];

	sprintf(cpData, "cp %s %s", SAVE_VOIP_CFG_TO_FLASH, SAVE_MTD_2_TEMP_NAME);
	system(cpData);

	memset(cpData, 0, 1024);
	fpMtd = fopen(SAVE_MTD_2_TEMP_NAME, "r");
	if(fpMtd == NULL)
		return ERROR_MSG_UPDATE_TFTP;

	fread(cpData, 1, 1024, fpMtd);
	fclose(fpMtd);

	sprintf(caCmd, "rm %s", SAVE_MTD_2_TEMP_NAME);
	system(caCmd);

	return MSG_OK;
}

//a_1_1
int get_etc_version_integer(char *cpOrgVer, int *ipEtcVer)
{
	if(get_version_from_etc_version(cpOrgVer) != MSG_OK)
	{
		return ERROR_MSG_UPDATE_TFTP;
	}
	sscanf(cpOrgVer, "%*c%d.%d.%d", &ipEtcVer[0], &ipEtcVer[1], &ipEtcVer[2]);

	DEBUG_PRINT("\t\t\tFW_VERSION:\n\t\t\t\t%d.%d.%d\n", ipEtcVer[0], ipEtcVer[1], ipEtcVer[2]);
	return MSG_OK;
}

void get_cfg_file_version(char *cpFileData, char *cpFileVersion)
{
	char caRetData[FILENAME_MAX_LEN] = "";

	if(get_spec_data_from_file(cpFileData, CHECK_CFG_FILE_VERSION, caRetData) != MSG_OK)	/* MSG_OK = 0 */
	{
		if(strlen(cpFileVersion) == 0)
		{
			/* Get the file Name... */
			strcpy(cpFileVersion, "");
			//get_default_cfg_file_name(cpFileName);
			DEBUG_PRINT("%s: NULL...\n\tCouldn't get the file version...\n", CHECK_CFG_FILE_VERSION);
		}
		DEBUG_PRINT("%s_with_length more over 1:%s\n", CHECK_CFG_FILE_VERSION, cpFileVersion);
	}
	else
	{
		memcpy(cpFileVersion, caRetData, strlen(caRetData));		
		DEBUG_PRINT("File get %s:%s\n", CHECK_CFG_FILE_VERSION, cpFileVersion);
	}
}
