#####################################################
#  Firmware and Radio auto compilation information  #
#####################################################

#---------------------------------------------------------#
# that makefile support 2 Firmware files and 2 Radio files.
#
# 1) all the file should be in *.Bin format
# 2) each file may have a comment, which usally carries verion 
#    or any user information - the comment should be one line. 
#
#---------------------------------------------------------#

ifndef _FW_MK_
export _FW_MK_= 1
#---------------------------------------------------------#

########################
# ---- TNETW 1130 ---- #
########################
ifeq ($(WLAN_CHIP),1130)

#---------------------------------------------------------#
# First Firmware file 
export ACX100_MSG_0          = "fw_radia_1130_ap.bin 0.3.16.14 - bg"
export ACX100_FW_FILE_0_BIN  = fw_radia_1130_ap
#---------------------------------------------------------#

#---------------------------------------------------------#
# Second Firmware file 
export ACX100_MSG_1          = "fw_radiadb_1130_ap.bin 0.3.16.14 - bg"
export ACX100_FW_FILE_1_BIN  = fw_radiadb_1130_ap
#---------------------------------------------------------#

endif


########################
# ---- TNETW 1150 ---- #
########################
ifeq ($(WLAN_CHIP),1150)

#---------------------------------------------------------#
# First Firmware file 
export ACX100_MSG_0          = "fw_dcrhp_1150_ap.bin 0.0.0.1 - abg"
export ACX100_FW_FILE_0_BIN  = fw_dcrhp_1150_ap
#---------------------------------------------------------#

#---------------------------------------------------------#
# Second Firmware file 
export ACX100_MSG_1          = "victoria_radia_tnetw1150.bin 0.0.0.1 - bg"
export ACX100_FW_FILE_1_BIN  = victoria_radia_tnetw1150
#---------------------------------------------------------#


endif

#---------------------------------------------------------#
endif

