/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/******************************************************************************/

/*! \file  dda_proc.h                                               
    \brief api functions for proc use                                                                          
*/
/******************************************************************************/

#ifndef  _DDA_PROC_H_
#define  _DDA_PROC_H_

#ifdef _DDA_PROC_C
#   define  PUBLIC
#else
#   define  PUBLIC  extern
#endif

PUBLIC int dda_read_proc_entry(const int dir, const int entry, 
						const char *buf, const int buf_len);

PUBLIC int dda_write_proc_entry(const int dir, const int entry, 
						const char *buf, const int buf_len);

PUBLIC int dda_print_proc_entry(const int dir, const int entry);


#undef PUBLIC
#endif /* _DDA_PROC_H_ */

