/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2005 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/*!
                                                                          
    \file  	wcfg_nvs.h                                               
    \brief 	PURPOSE: This module implements non volatile storage API.
                                                                          
*/

#ifndef __WCFGLIB_NVS_H
#define __WCFGLIB_NVS_H

#ifdef _WCFGLIB_NVS_C
#   define  PUBLIC
#else
#   define  PUBLIC  extern
#endif

PUBLIC int  wcfg_nvs_read_data( const wcfgd *wd, tiap_param_eeprom_t * pEeprom, 
                                int * pNvsDefault );

PUBLIC void wcfg_nvs_set_default_data( tiap_param_eeprom_t * pEeprom );

#undef PUBLIC
#endif
