#include <stdlib.h>
#include <stdio.h>
typedef struct{
	u_int8_t	magic_s[7];	/* sErCoMm */
	u_int8_t	ver_control[2];	/* version control */
	u_int8_t	download[2];	/* download control */
	u_int8_t	hw_id[32];  	/* H/W ID */ 
	u_int8_t	hw_ver[2];  	/* H/W version */
	u_int8_t	p_id[4];    	/* Product ID */
	u_int8_t	protocol_id[2];	/* Protocol ID */	
	u_int8_t	fun_id[6];	/* Function ID */
	u_int8_t	fw_ver[2];	/* F/W version */
	u_int8_t	start[2];	/* Starting code segment */
	u_int8_t	c_size[2];	/* Code size (kbytes) */
	u_int8_t	magic_e[7];	/* sErCoMm */
}sercomm_pid_t;

int main(void)
{
	FILE *fp;
	sercomm_pid_t pid;
	char hw_id[32];	
	/* get hw id */
	fp=fopen("/dev/mtdblock/0","r");
		
	fseek(fp,-78,SEEK_END);
	fread(&pid,70,1,fp);
	fclose(fp);
	printf("hw_id==%s\n",pid.hw_id);
	printf("p_id==%c%c%c%c\n",pid.p_id[0],pid.p_id[1],pid.p_id[2],pid.p_id[3]);
	return 0;
}
